(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: EDDIE.PAS                                                      *)
(*  Obsah: editor na rastrove obrazky (*.OBR)                              *)
(*  Autor: Mircosoft                                                       *)
(*  Posledni uprava: 5.10.2007                                             *)
(*  Pro kompilaci: viz uses                                                *)
(*  Pro spusteni: MSDFTL.FNT, STDSIPKA.KUR, STETEC.KUR, KRIZ.KUR,          *)
(*                TUZKA.KUR, SPREJ.KUR                                     *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)

{struktura *.OBR souboru ([tohle] jsou nepovinne casti):

 pocet obrazku v souboru (word)
 sirka jednoho obrazku (word)
 vyska jednoho obrazku (word)
 prvni obrazek (prislusna hromada pixelu)
 [druhy obrazek ...]
 [treti ...]

Z toho vyplyva, ze do jednoho souboru se da ulozit vic obrazku nez jeden, ale
musi byt stejne velke.
Pro nacitani obrazku ze souboru do datove struktury v pameti slouzi typ
tObrazky v jednotce Grafika3, pro jejich zobrazovani libovolny Putimage z
jednotky SVGA/VESA. Zadna specialni procedura na to neni, je nutne z typu
tObrazky spravne vytahnout prislusny ukazatel na bitmapu:
 _putimage(nejake_x,nejake_y,obr.sirka,obr.vyska,obr.data^[cislo_obrazku]);
(polozka Data je ukazatel na pole ukazatelu, ktere teprve ukazuji na vlastni
obrazova data; to proto, aby mohl byt pocet obrazku dynamicky)

Data v souboru se muzou ulozit komprimovane (jednoducha, ale pomerne ucinna
RLE+ komprese; ucinnost klesa s rostouci clenitosti obrazku). Pokud je soubor
komprimovany, ma polozka Pocet nastaven nejvyssi bit na 1, jinak na 0. Tim se
sice tento bit zabere, takze nemuze byt 65535 obrazku, ale jen polovina, ale
komu by to vadilo :-). V pameti nactene obrazky komprimovane nejsou.

Format dat v souboru je bez komprese array[1..vyska,1..sirka] of byte -
 - proste pixely (co byte, to pixel) ulozene po radcich za sebou. S kompresi
je to jenom o trochu slozitejsi: nejdriv informacni byte, ten ma bud nejvyssi
bit nastaven na 1 a pak jeho ostatni bity rikaji, kolikrat se ma pixel
nasledujici po tomto bytu zopakovat, nebo tam ma 0 a ostatni bity pak urcuji,
kolik za nim nasleduje nezkomprimovanych pixelu (komprese se totiz vyplati
az kdyz jsou aspon 3 stejne pixely za sebou).
(Diky za info, Martine)}

program Mircosoft_Eddie;
{$R-} {vypnuti kontroly rozsahu, aby se umoznily triky s dynamickymi poli}
{$I-} {vypnuti kontroly operaci se soubory, aby fungoval IOresult a program nepadal}
{$X-,Q-,E-,B-}
uses vesa,mys3,woknows3,grafika3,paleta2,klavesy,retezce,matyka,disk,konst,cas,pcx,cfg;
type polebytu=array[0..0]of byte; uknapb=^polebytu;{pomocne typy pro pristup k jednotlivym pixelum obrazku}
var kstetec,ktuzka,kkriz,ksprej:tkurzor;{ruzne kurzory (o standardni sipku se stara jednotka Woknows)}
    stetec:byte;{0 = tuzka, 1 = stetec, 2 = sprej}
    velst,velsp:byte;{velikost stetce a spreje}
    silaspreje:word;{cekani mezi dvema kapkami pro sprej}
    obr:tobrazky;{datova struktura pro ulozeni obrazku v pameti}
    pal:^rgbpal256;{pro nacitani palety}
    soubor,pom:string[79];{jmeno souboru, kam se bude ukladat, a jeden pomocny retezec}
    o,{pro klavesnici}
    zoom,{zvetseni (1..dokud se to vejde na obrazovku)}
    indexobrazku:word;{cislo aktualne vybraneho obrazku}
    lbarva,pbarva:byte;{barva pro kresleni levym a pravym mysitkem}
    x,y:word; x2,y2:integer;{pomocne}
    mrizkab:boolean;{ma se kreslit mrizka? (zobrazi se jen pri zoom>2)}
    vt,rt:byte;{naposledy pouzita velikost a roztec textu}
    tmps,tmpv:word;   {\                       }
    tmpo:pointer;     { \ pro kopirovani vyrezu}
    tmpp:sprite;      { /                      }
    pruhledne:boolean;{/                       }
    komprimovat:boolean;{jestli se maji obrazky ukladat komprimovane}

procedure ObnovKurzor;{nastavi kurzor, ktery ma normalne byt nastaveny}
Begin
case stetec of 0:nastavkurzor(ktuzka);
               1:nastavkurzor(kstetec);
               2:nastavkurzor(ksprej);
               end;
End;{obnovkurzor}

procedure KresliMrizku;
Begin
if mrizkab and(zoom>2) then {pri malem zvetseni by mrizka prekryla obrazek, coz nechceme}
  begin
  kvyp;
  for x:=0 to obr.sirka-1 do __vline(zoom*x+zoom-1,0,(obr.vyska-1)*zoom+zoom-1,5);
  for x:=0 to obr.vyska-1 do __hline(0,(obr.sirka-1)*zoom+zoom-1,zoom*x+zoom-1,5);
  kzap;
  end;
End;{KresliMrizku}

procedure NatahniObrazek;{vykresli aktualni obrazek z pameti na obrazovku}
var x,y:word;
Begin
kvyp;
with obr do begin
            for y:=0 to vyska-1 do
             for x:=0 to sirka-1 do
              if mrizkab and(zoom>2) then _bar(x*zoom,y*zoom,x*zoom+zoom-2,y*zoom+zoom-2,
                                               polebytu(data^[indexobrazku]^)[y*sirka+x])
                                     else _bar(x*zoom,y*zoom,x*zoom+zoom-1,y*zoom+zoom-1,
                                               polebytu(data^[indexobrazku]^)[y*sirka+x]);
            __vline(sirka*zoom,0,vyska*zoom,14); {okraj}
            __hline(0,sirka*zoom,vyska*zoom,14);
            end;
kzap;
End;{natahniobrazek}

procedure UlozObrazek;{nacte do pameti to, co je na obrazovce}
var i,j:word;
Begin
kvyp;
with obr do for i:=0 to vyska-1 do
             for j:=0 to sirka-1 do polebytu(data^[indexobrazku]^)[i*sirka+j]:=_getpixel(j*zoom,i*zoom);
kzap;
End;{ulozobrazek}

procedure save;{ulozeni do souboru}
var f:file;
    i,index,index2,poc,pocet2,velikost:word;
    pix,b:byte;
    vs:real;
Begin
assign(f,soubor);
rewrite(f,1);
if ioresult<>0 then exit;
with obr do
  begin
  velikost:=sirka*vyska;
  if komprimovat then begin
                      i:=pocet or $8000;{nastaveni nejyssiho bitu na 1}
                      blockwrite(f,i,2);
                      end
                 else blockwrite(f,pocet,2);
  blockwrite(f,sirka,2);
  blockwrite(f,vyska,2);
  if komprimovat then for i:=1 to pocet do
                       begin
                       index:=0;
                       index2:=0;
                       poc:=0;
                        repeat
                        pix:=uknapb(data^[i])^[index2];
                        pocet2:=0;
                         repeat
                         inc(index2);
                         inc(pocet2);
                         until (uknapb(data^[i])^[index2]<>pix)or(index2>=velikost);
                        if pocet2>=3 then begin{zabalit a zapsat}
                                          if poc<>0 then begin{zapis predchozich nekomprimovanych pixelu}
                                                         b:=$7F;
                                                         while poc>$7F do begin
                                                                          {protoze pocet muze byt vetsi nez se vejde do bytu}
                                                                          blockwrite(f,b,1);
                                                                          blockwrite(f,uknapb(data^[i])^[index],$7F);
                                                                          inc(index,$7F);
                                                                          dec(poc,$7F);
                                                                          end;
                                                         blockwrite(f,poc,1);{zapis zbytku, ktery se uz do bytu vejde}
                                                         blockwrite(f,uknapb(data^[i])^[index],poc);
                                                         poc:=0;
                                                         end;
                                          b:=$FF;
                                          while pocet2>$7F do begin{zase, kdyz se nevejde do info bytu}
                                                              dec(pocet2,$7F);
                                                              blockwrite(f,b,1);
                                                              blockwrite(f,pix,1);
                                                              end;
                                          b:=pocet2 or $80;
                                          blockwrite(f,b,1);{a zbytek}
                                          blockwrite(f,pix,1);
                                          index:=index2;
                                          end
                                     else begin{nebalit}
                                          inc(poc,pocet2);{zapise se az za chvili}
                                          end;
                        until index2>=velikost;{dokud nedojdeme na konec obrazku}
                       if poc<>0 then begin{jeste zapis nezabalenych pixelu z konce}
                                      b:=$7F;
                                      while poc>$7F do begin
                                                       blockwrite(f,b,1);
                                                       blockwrite(f,uknapb(data^[i])^[index],$7F);
                                                       inc(index,$7F);
                                                       dec(poc,$7F);
                                                       end;
                                      blockwrite(f,poc,1);
                                      blockwrite(f,uknapb(data^[i])^[index],poc);
                                      end;
                       end
                 else for i:=1 to pocet do blockwrite(f,data^[i]^,velikost);{bez komprese}
  end;
vs:=filesize(f)/1024;{velikost souboru v kB}
close(f);
if ioresult=0 then infokno(320,240,'spn uloeno ('+nastrr(vs,2)+' kB).',true);
End;{save}

procedure load;{nacte obrazky ze souboru; pokud soubor neexistuje, necha zadat parametry rucne}
Begin
if obr.pocet<>0 then zrusobrazky(obr);
nactiobrazky2(obr,soubor);{o dekompresi se postara tahle procedura - viz jednotku Grafika 3}
if obr.pocet<>0 then begin{kdyz se nacteni podarilo}
                     if indexobrazku>obr.pocet then indexobrazku:=obr.pocet;
                     if mrizkab then kreslimrizku;
                     infokno(320,240,'spn nateno.',true);
                     end
                else with obr do begin{kdyz se nepodarilo}
                                 sirka:=30; vyska:=30;
                                  repeat
                                  pocet:=vlozcislookno('Poet obrzk:',1,30000,1);
                                   repeat
                                   sirka:=vlozcislookno('ka:',1,_maxx+1,sirka);
                                   vyska:=vlozcislookno('Vka:',1,_maxy,vyska);
                                   if (longint(sirka)*vyska>maxavail)or(longint(sirka)*vyska>$FFFF) then okokno(
                                                           'Takhle velk obrzek se nevejde do pamti.|'
                                                          +'Zadejte prosm trochu men rozmry.');
                                   until (longint(sirka)*vyska<=maxavail)and(longint(sirka)*vyska<=$FFFF);
                                  if longint(sirka)*vyska*pocet+(pocet shl 2)>memavail then okokno(
                                                  'Obrzk je bu pli mnoho nebo jsou moc|'
                                                 +'velk, zkrtka na n nen dost pamti.|'
                                                 +'Zadejte prosm jin parametry.');
                                  until longint(sirka)*vyska*pocet+(pocet shl 2)<=memavail;
                                 getmem(data,pocet shl 2);
                                 for x:=1 to pocet do begin
                                                      getmem(data^[x],sirka*vyska);
                                                      fillchar(data^[x]^,sirka*vyska,0);
                                                      end;
                                 indexobrazku:=1;
                                 end;
natahniobrazek;
End;{load}

procedure pixel(x,y:integer;b:byte);{nakresli pixel na obrazovku a pokud to jde, i do obrazku v pameti}
Begin
with obr do if (x>=0)and(y>=0)and(x<sirka)and(y<vyska) then uknapb(data^[indexobrazku])^[y*sirka+x]:=b;
if zoom=1 then _putpixel(x,y,b) else
 if mrizkab and(zoom>2) then __bar(x*zoom,y*zoom,x*zoom+zoom-2,y*zoom+zoom-2,b)
                        else __bar(x*zoom,y*zoom,x*zoom+zoom-1,y*zoom+zoom-1,b);
End;{pixel}

procedure floodfill(_hx,_hy:integer;barva:byte);{jako plechovka v Malovani}
type polepixelu=array[0..0] of record
                               y,x:word;
                               end;
     uknapolepixelu=^polepixelu;
var pix:byte;{pro ulozeni barvy pixelu, na kterou bylo kliknuto a pres kterou se nova barva "rozlije"}
    pp:uknapolepixelu;{zasobnik}
    velikost,{velikost zasobniku}
    i,j,{pomocne souradnice}
    vrchni,{index prvni volne pozice nad vrcholem zasobniku}
    max:word;{max. mozny index zasobniku (zavisi na jeho velikosti)}
{}procedure _push(_x,_y:word);
{}Begin
{}if vrchni<max then begin
{}                   with pp^[vrchni] do begin
{}                                       x:=_x; y:=_y;
{}                                       end;
{}                   inc(vrchni);
{}                   end;
{}End;{_push}
{}procedure _pop(var _x,_y:word);
{}Begin
{}if vrchni<>0 then begin
{}                  dec(vrchni);
{}                  with pp^[vrchni] do begin
{}                                      _x:=x; _y:=y;
{}                                      end;
{}                  end
{}             else begin
{}                  _x:=10000; _y:=10000;{procedura pochopi, ze je to kravina a nic nenakresli}
{}                  end;
{}End;{_pop}
Begin{floodfill}
if (_hx<obr.sirka)and(_hy<obr.vyska) then
  begin
  with obr do pix:=uknapb(data^[indexobrazku])^[sirka*_hy+_hx];
  if pix=barva then exit;
  velikost:=64000; if velikost>maxavail then velikost:=maxavail;{jak velky si muzeme dovolit?}
  getmem(pp,velikost);{alokace zasobniku}
  max:=velikost shr 2;{velikost/4 = max. pocet polozek v zasobniku}
  vrchni:=0;{vrchol zasobniku}
  _push(_hx,_hy);{zacneme v bode, kam se kliklo}
  with obr do repeat
              _pop(j,i);{precteme souradnice pixelu}
              pixel(j,i,barva);{vybarvime ho}
              {pixel nahore (pokud se nad timhle nachazi pixel, ktery se ma vybarvit, ulozime ho)}
              if (i>0)and(uknapb(data^[indexobrazku])^[(i-1)*sirka+j]=pix) then _push(j,i-1);
              {pixel dole: (to same)}
              if (i<vyska-1)and(uknapb(data^[indexobrazku])^[(i+1)*sirka+j]=pix) then _push(j,i+1);
              {pixel vlevo:}
              if (j>0)and(uknapb(data^[indexobrazku])^[i*sirka+j-1]=pix) then _push(j-1,i);
              {pixel vpravo:}
              if (j<sirka-1)and(uknapb(data^[indexobrazku])^[i*sirka+j+1]=pix) then _push(j+1,i);
              until vrchni=0;{koncime, kdyz jsou vybarveny vsechny pixely ulozene v zasobniku}
  freemem(pp,velikost);{zruseni zasobniku}
  end;
{Jak ze to funguje:
Mame zasobnik, do ktereho ukladame souradnice tech pixelu, ktere se maji
vybarvit. Na zacatku do nej tedy ulozime souradnice vychoziho bodu (kliknuti).
V cyklu pak vzdycky jedny souradnice ze zasobniku precteme, vybarvime
prislusny pixel, a ulozime do nej souradnice vsech okolnich pixelu, ktere
splnuji podminky pro vybarveni (maji tu spravnou barvu a lezi uvnitr obrazku).
Extra velke plochy se nevyplni cele, protoze nestaci velikost zasobniku.}
End;{floodfill}

BEGIN
cfgsoubor:='EDDIE.CFG';
_frekvence:=75;
_setmode(_640x480); initmys; initwoknows; {automatiku mysi nezapinat!!!}
nactinastavenimysi;
nactikurzor2(kstetec,'stetec.kur');
nactikurzor2(kkriz,'kriz.kur');
nactikurzor2(ktuzka,'tuzka.kur');
nactikurzor2(ksprej,'sprej.kur');
if paramcount>=2 then soubor:=paramstr(2)
                 else soubor:=vybersouborokno('Soubor s paletou:','PAL','');
if soubor<>'' then begin {nastaveni palety}
                   new(pal);
                   if nactipaletu(pal^,soubor) then nastavpaletu(pal^,0,255,100);
                   dispose(pal);
                   end;
if paramcount=0 then repeat {rucni zadani jmena souboru}
                     soubor:=vybersouborokno('Soubor s obrzkem:','OBR','')
                     until soubor<>''
                else soubor:=paramstr(1); {precteni jmena souboru z parametru}
{inicializace hodnot, u nekterych nutna jeste pred loadnutim:}
obr.pocet:=0; o:=0; zoom:=1; lbarva:=15; pbarva:=0; velst:=1;
velsp:=3; mrizkab:=false; vt:=1; pom:=''; rt:=8; pruhledne:=false; stetec:=0;
komprimovat:=ano; silaspreje:=15; startcekani; indexobrazku:=1;
_print(1,470,7,'Pro npovdu stisknte F1.'); _print(620,470,2,' 1');
load;
nastavkurzor(ktuzka); kzap; resetuj;
 Repeat {hlavni cyklus}
 cekej;
 if lmys then begin{kresleni prvni barvou}
              {skutecne souradnice:}
              x:=xmys div zoom;
              y:=ymys div zoom;
              kvyp;
              case stetec of 0:pixel(x,y,lbarva);
                             1:for y2:=y-velst to y+velst do
                                for x2:=x-velst to x+velst do pixel(x2,y2,lbarva);
                             2:if dosazencas(silaspreje) then begin
                                                              pixel(x-velsp+random(velsp shl 1+1),
                                                                    y-velsp+random(velsp shl 1+1),lbarva);
                                                              startcekani;
                                                              end;
                             end;
              kzap;
              end
  else if pmys then begin{kresleni druhou barvou}
                    x:=xmys div zoom;
                    y:=ymys div zoom;
                    kvyp;
                    case stetec of 0:pixel(x,y,pbarva);
                                   1:for y2:=y-velst to y+velst do
                                      for x2:=x-velst to x+velst do pixel(x2,y2,pbarva);
                                   2:if dosazencas(silaspreje) then begin
                                                                    pixel(x-velsp+random(velsp shl 1+1),
                                                                          y-velsp+random(velsp shl 1+1),pbarva);
                                                                    startcekani;
                                                                    end;
                                   end;
                    kzap;
                    end
   else if keypressed then begin
                           o:=xreadkey;
                           case o of xctrlg:begin{mrizka}
                                            mrizkab:=not mrizkab;
                                            if mrizkab then kreslimrizku
                                                       else natahniobrazek;
                                            end;
                                     xdsipka:if zoom>1 then begin{zmenseni}
                                                            kvyp;
                                                            __bar(0,0,zoom*obr.sirka,zoom*obr.vyska,0);
                                                            dec(zoom);
                                                            natahniobrazek;
                                                            if mrizkab then kreslimrizku;
                                                            napis(350,470,2,0,nastr2(zoom,3));
                                                            end;
                                     xhsipka:if (zoom<(_maxx+1) div obr.sirka)and(zoom<(_maxy+1) div obr.vyska)
                                                       then begin{zvetseni}
                                                            inc(zoom);
                                                            natahniobrazek;
                                                            if mrizkab then kreslimrizku;
                                                            napis(350,470,2,0,nastr2(zoom,3));
                                                            end;
                                     ord('l'):lbarva:=vyberbarvuokno('Barva pro lev mytko:',lbarva);
                                     ord('p'):pbarva:=vyberbarvuokno('Barva pro prav mytko:',pbarva);
                                     ord('P'):begin{nacteni palety}
                                              nastavkurzor(wokkurzor);
                                              pom:=vybersouborokno('Nov paleta:','PAL','');
                                              if pom<>'' then begin
                                                              new(pal);
                                                              if nactipaletu(pal^,pom) then nastavpaletu(pal^,0,255,100);
                                                              dispose(pal);
                                                              end;
                                              obnovkurzor;
                                              end;
                                     xpsipka:if indexobrazku<obr.pocet then begin{dalsi obrazek}
                                                                            inc(indexobrazku);
                                                                            natahniobrazek;
                                                                            napis(620,470,2,0,nastr2(indexobrazku,2));
                                                                            end;
                                     xlsipka:if indexobrazku>1 then begin{predchozi obrazek}
                                                                    dec(indexobrazku);
                                                                    natahniobrazek;
                                                                    napis(620,470,2,0,nastr2(indexobrazku,2));
                                                                    end;
                                     xins:begin{kapatko}
                                          nastavkurzor(kkriz);
                                          resetuj; cekej;
                                          if lmys then lbarva:=_getpixel(xmys,ymys)
                                                  else if pmys then pbarva:=_getpixel(xmys,ymys);
                                          resetuj;
                                          obnovkurzor;
                                          end;
                                     ord('c'):begin{kresleni cary}
                                              nastavkurzor(kkriz);
                                              resetuj; cekej;
                                              x:=xmys div zoom; y:=ymys div zoom;
                                              resetuj; cekej;
                                              x2:=xmys div zoom; y2:=ymys div zoom;
                                              o:=zoom; zoom:=1; natahniobrazek;
                                              kvyp;
                                              __line(x,y,x2,y2,(ord(lmys)*lbarva)or(ord(pmys)*pbarva));
                                              {trapne jednoduche - snad jste necekali, ze sem ten
                                              Bresenhamuv algoritmus na kresleni cary prepisu? :-) }
                                              ulozobrazek;
                                              zoom:=o; o:=0;
                                              natahniobrazek;
                                              if mrizkab then kreslimrizku;
                                              resetuj;
                                              obnovkurzor;
                                              end;
                                     ord('b'):begin{kresleni obdelniku}
                                              nastavkurzor(kkriz);
                                              resetuj; cekej;
                                              x:=xmys div zoom; y:=ymys div zoom;
                                              resetuj; cekej;
                                              x2:=xmys div zoom; y2:=ymys div zoom;
                                              if x>x2 then asm
                                                           {prohozeni x a x2 - asm jen proto, abych nemusel pouzivat
                                                           zbytecne dalsi pomocne promenne, kdyz na to staci registry}
                                                           mov AX,x
                                                           mov BX,x2
                                                           mov x,BX
                                                           mov x2,AX
                                                           end;
                                              if y>y2 then asm
                                                           mov AX,y
                                                           mov BX,y2
                                                           mov y,BX
                                                           mov y2,AX
                                                           end;
                                              kvyp;
                                              for ymys:=y to y2 do
                                               for xmys:=x to x2 do pixel(xmys,ymys,(ord(lmys)*lbarva)or(ord(pmys)*pbarva));
                                              {prasacke vyuziti souradnic mysi jako pomocnych promennych :-)}
                                              kzap;
                                              resetuj;
                                              obnovkurzor;
                                              end;
                                     ord('e'):begin{kresleni elipsy}
                                              nastavkurzor(kkriz);
                                              resetuj; cekej;
                                              x:=xmys div zoom; y:=ymys div zoom;
                                              resetuj; cekej;
                                              x2:=xmys div zoom; y2:=ymys div zoom;
                                              o:=zoom; zoom:=1; natahniobrazek;
                                              kvyp;
                                              if shiftpressed then __ellipse(x,y,vzdalbodu(x,y,x2,y2),vzdalbodu(x,y,x2,y2),
                                                                              (ord(lmys)*lbarva)or(ord(pmys)*pbarva))
                                                              else __ellipse(x,y,abs(integer(x2)-x),abs(integer(y2)-y),
                                                                              (ord(lmys)*lbarva)or(ord(pmys)*pbarva));
                                              ulozobrazek;
                                              zoom:=o; o:=0;
                                              natahniobrazek;
                                              if mrizkab then kreslimrizku;
                                              resetuj;
                                              obnovkurzor;
                                              end;
                                     ord('t'):begin{kresleni textu}
                                            if zoom>1 then okokno('POZOR!!!|Nat se obsah obrazovky bez ohledu na mtko!');
                                              nastavkurzor(kkriz);
                                              resetuj; cekej;
                                              x:=xmys; y:=ymys;
                                              nastavkurzor(wokkurzor);
                                              pom:=vloztextokno('',60,pom,ne);
                                              vt:=vlozcislookno('Velikost textu:',1,1000,vt);
                                              if vt<1 then vt:=1;
                                              rt:=vlozcislookno('Rozte psmen v pixelech:',1,1000,rt);
                                              obnovkurzor;
                                              kvyp;
                                              _pushtext;
                                              _nastavtext(vt,vt,rt);
                                              _print(x,y,lbarva,pom);
                                              _poptext;
                                              ulozobrazek;
                                              end;
                                     xdel:begin{vymazani aktualniho obrazku (vyplneni pbarvou)}
                                          fillchar(obr.data^[indexobrazku]^,obr.sirka*obr.vyska,pbarva);
                                          natahniobrazek;
                                          end;
                                     ord('k'):begin{kopie celeho aktualniho obrazku nekam}
                                              x:=vlozcislookno('Kam koprovat?',1,obr.pocet,indexobrazku);
                                              with obr do move(data^[indexobrazku]^,data^[x]^,sirka*vyska);
                                              infokno(320,240,
                                               'Obrzek . '+nastr(indexobrazku)+' zkoprovn na pozici .'+nastr(x),true);
                                              end;
                                     ord('v'):begin{vyber vyrezu a manipulace s nim}
                                              nastavkurzor(kkriz);
                                              resetuj; cekej;
                                              x:=xmys; y:=ymys;
                                              resetuj; cekej;
                                              x2:=xmys; y2:=ymys;
                                              if x>x2 then asm
                                                           mov AX,x
                                                           mov BX,x2
                                                           mov x,BX
                                                           mov x2,AX
                                                           end;
                                              if y>y2 then asm
                                                           mov AX,y
                                                           mov BX,y2
                                                           mov y,BX
                                                           mov y2,AX
                                                           end;
                                              tmps:=x2-x+1; if tmps=0 then tmps:=1;
                                              tmpv:=y2-y+1; if tmpv=0 then tmpv:=1;
                                              {je dost pameti?:}
                                              if longint(tmps)*tmpv*2>maxavail then okokno(
                                                      'Takhle velk vez se nevejde do pamti.')
                                              else begin
                                              if not tmpp.init(tmps,tmpv) then ;{pameti je dost, to uz vime}
                                              getmem(tmpo,tmps*tmpv);
                                              kvyp;
                                              tmpp.nacti(x,y);{nacteni pozadi}
                                              _getimage(x,y,x2,y2,tmpo);{nacteni vybraneho vyrezu}
                                              presunmys(x,y);
                                              resetuj;
                                               repeat
                                               cekejnacokoli;
                                               tmpp.zobraz(x,y);{zobrazeni pozadi}
                                               x:=xmys; y:=ymys;{nove souradnice}
                                               tmpp.nacti(x,y);{nacteni noveho pozadi}
                                               if pruhledne then _puttimage(x,y,tmps,tmpv,tmpo){vykresleni vyrezu}
                                                            else _putimage(x,y,tmps,tmpv,tmpo);
                                               if pmys then begin
                                                            pruhledne:=not pruhledne;{prave mysitko prepina pruhlednost}
                                                            resetuj;
                                                            end;
                                               until lmys;{levym mysitkem se konci}
                                              ulozobrazek;{ulozeni obsahu obrazovky}
                                              natahniobrazek;
                                              if mrizkab then kreslimrizku;
                                              freemem(tmpo,tmps*tmpv); tmpp.zrus;{uvolneni pameti}
                                                   end;{if je_dost_pameti}
                                              resetuj;
                                              obnovkurzor;
                                              end;
                                     ord('f'):begin{plechovka}
                                              nastavkurzor(kkriz);
                                              resetuj; cekej;
                                              x:=xmys div zoom; y:=ymys div zoom;
                                              kvyp;
                                              if lmys then floodfill(x,y,lbarva)
                                                      else if pmys then floodfill(x,y,pbarva);
                                              obnovkurzor;
                                              kzap;
                                              resetuj;
                                              end;
                                     ord('s'):begin
                                              inc(stetec);
                                              if stetec=3 then stetec:=0;
                                              obnovkurzor;
                                              end;
                                     xpgup:case stetec of 1:begin
                                                            if velst<255 then inc(velst);{zvetseni stetce}
                                                            napis(400,470,2,0,nastr2(velst,4));
                                                            end;
                                                          2:begin
                                                            if velsp<255 then inc(velsp);{zvetseni spreje}
                                                            napis(450,470,2,0,nastr2(velsp,4));
                                                            end;
                                                          end;
                                     xpgdn:case stetec of 1:begin
                                                            if velst>0 then dec(velst);{zmenseni stetce}
                                                            napis(400,470,2,0,nastr2(velst,4));
                                                            end;
                                                          2:begin
                                                            if velsp>0 then dec(velsp);{zmenseni spreje}
                                                            napis(450,470,2,0,nastr2(velsp,4));
                                                            end;
                                                          end;
                                     ord('-'):if silaspreje<$1000 then begin
                                                                       inc(silaspreje,3);
                                                                       napis(500,470,2,0,nastr2(silaspreje,4));
                                                                       end;
                                     ord('+'):if silaspreje>3 then begin
                                                                   dec(silaspreje,3);
                                                                   napis(500,470,2,0,nastr2(silaspreje,4));
                                                                   end;
                                     xF2:save;
                                     xF3:load;
                                     xF4:if komprimovat then begin{zapnuti nebo vypnuti komprese}
                                                             komprimovat:=ne;
                                                             infokno(320,240,'Nastaveno ukldn bez komprese.',ano);
                                                             end
                                                        else begin
                                                             komprimovat:=ano;
                                                             infokno(320,240,'Nastaveno ukldn s kompres.',ano);
                                                             end;
                                     13:begin{zmena souboru}
                                        nastavkurzor(wokkurzor);
                                        pom:=vybersouborokno('','OBR','');
                                        if pom<>'' then begin
                                                        if anoneokno('M se pvodn soubor uloit?') then save;
                                                        soubor:=pom;
                                                        if anoneokno('M se nast obsah novho souboru?') then
                                                          begin
                                                          kvyp;
                                                          _fill(0);
                                                          indexobrazku:=1;
                                                          zoom:=1;
                                                          napis(620,470,2,0,nastr2(indexobrazku,2));
                                                          load;
                                                          end;
                                                        end;
                                        obnovkurzor;
                                        end;
                                     ord('z'):zjistujsouradnice;
                                     ord('m'):nastavmysokno(true);
                                     ord('x'):begin
                                              pom:=vloztextokno('Jmno bez koncovky:',8,'SCRNSHOT',true);
                                              if pom<>''
                                                then if ulozpcx(0,0,(obr.sirka-1)*zoom,(obr.vyska-1)*zoom,pom,
                                                                vloztextokno('Njak koment?',57,'',false),true)
                                                       then infokno(320,240,'Obrzek spn uloen ve formtu PCX.',true)
                                                       else infokno(320,240,'Ukldn do PCX se nezdailo!',true);
                                              end;
                                     xF1:begin{info}
                                         kvyp;
                                         _fill(0);
                                         _rectangle(552,0,639,28,9);
                                         _print(561,5,9,'Mircosoft');
                                         _print(561,15,9,'Eddie 7.4');
      _print(14,10,15,'Seznam ovldacch prvk:');
      _print(4,20,7,'F1: tato npovda');
      _print(4,30,7,'F2: uloen do souboru');
      _print(4,40,7,'F3: naten ze souboru');
      _print(4,50,7,'F4: zapne nebo vypne kompresi pi ukldn do souboru (vchoz = zapnuto)');
      _print(4,60,7,'Enter: zmna souboru');
      _print(4,70,7,'Shift+P: naten barevn palety ze souboru');
      _print(4,80,7,'Esc: konec (pozor, bez ptan!)');
      _print(4,100,7,'Ctrl+G: zapne nebo vypne mku');
      _print(4,110,7,hsipkazn+','+dsipkazn+': zmenen nebo zvten obrzku');
      _print(4,120,7,lsipkazn+','+psipkazn+': pepnn mezi obrzky');
      _print(4,130,7,'Del: vymazn aktulnho obrzku (tj. vyplnn barvou pro prav mytko)');
      _print(4,140,7,'K: zKoprovn aktulnho obrzku na jinou pozici');
      _print(4,160,7,'L: nastaven barvy pro kreslen Levm mytkem');
      _print(4,170,7,'P: nastaven barvy pro kreslen Pravm mytkem');
      _print(4,180,7,'S: pepnn mezi ttcem, tukou a sprejem');
      _print(4,190,7,'PgUp, PgDn: zmna velikosti ttce nebo spreje, podle toho, m zrovna kreslte');
      _print(4,200,7,'+,-: nastaven sly spreje (men slo = silnj sprej)');
      _print(4,210,7,'Ins: kaptko, nastav barvu podle msta, kam kliknete');
      _print(4,220,7,'C: nakreslen ry: kliknutm zadejte dva body, ra bude mt barvu podle toho,');
      _print(4,230,7,'   kterm mytkem odkliknete ten druh.');
      _print(4,240,7,'B: vyplnn oBdlnk, zadvn a barva jako u ry');
      _print(4,250,7,'E: Elipsa. Prvnm klikem zadte sted, druhm bu zadte jeden roh obdlnku');
      _print(4,260,7,'   opsanho elipse nebo podrte Shift a vzdlenost druhho kliku od prvnho');
      _print(4,270,7,'   ur polomr a nakresl se krunice.');
      _print(4,280,7,'   Barva opt podle levho nebo pravho mytka pi druhm kliknut.');
      _print(4,290,7,'T: Text. Kliknutm zadejte lev horn roh a vyplte poadovan parametry.');
      _print(4,300,7,'   Pi zvten > 1 me dojt ke ztrtm. Barva vdy podle levho mytka.');
      _print(4,310,7,'V: dvma kliky vyberete obdlnkov Vez obrazovky. Potom s nm mete my');
      _print(4,320,7,'   pohybovat. Prav mytko zapn nebo vypn prhlednost barvy . 0,');
      _print(4,330,7,'   lev mytko manipulaci s vezem ukon.');
      _print(4,340,7,'F: plechoFka. Barva se rozlije od zadanho bodu vemi smry, dokud se nezaraz');
      _print(4,350,7,'   o njakou jinou. Pokud je vyplovan oblast tak velk, e nevysta pam؜,');
      _print(4,360,7,'   zbyde pr nevyplnnch flk. Barva podle toho, kterm mytkem kliknete.');
      _print(4,370,7,'Z: Zjiovn souadnic na obrazovce pomoc myi (obas se hod).');
      _print(14,390,15,'My:');
      _print(4,400,7,'lev tlatko: kreslen barvou 1');
      _print(4,410,7,'prav tlatko: kreslen barvou 2');
      _print(4,420,7,'M: nasteven vlastnost myi (citlivost, prohozen tlatek atd.)');
      _print(4,440,7,'Kreslit se d kamkoli na obrazovku, ale ulo se jen to, co je uvnit');
      _print(4,450,7,'lutho rmeku, kter zan v levm hornm rohu obrazovky.');
                                         resetuj; cekej; resetuj;
                                         _fill(0);
                                         natahniobrazek;
                                         if mrizkab then kreslimrizku;
                                         napis(620,470,2,0,nastr2(indexobrazku,2));
                                         kzap;
                                         end;
                                     end;
                           end;
 Until (o=27) and anoneokno('Opravdu konec?');{Esc}
zrusobsluhumysi;
zruskurzor(kstetec); zruskurzor(kkriz); zruskurzor(ktuzka);
zruswoknows; zrusobrazky(obr);
_setmode(0);
END.